'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _recompose = require('recompose');

var withPending = function withPending(keys) {
  return (0, _recompose.compose)((0, _recompose.withState)('pending', 'setPending', false), (0, _recompose.mapProps)(function (props) {
    var newProps = _extends({}, props);
    keys.forEach(function (key) {
      if (props[key]) {
        newProps[key] = function () {
          var promise = props[key]();
          if (promise && promise.then) {
            props.setPending(true);
            promise.then(function () {
              props.setPending(false);
            });
          }
        };
      }
    });
    return newProps;
  }));
};

exports.default = withPending;